VERSION 5.00
Begin VB.UserControl VJLogin 
   ClientHeight    =   3555
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4890
   PropertyPages   =   "VJLoginControl.ctx":0000
   ScaleHeight     =   3555
   ScaleWidth      =   4890
   ToolboxBitmap   =   "VJLoginControl.ctx":003D
   Begin VB.CommandButton cmdRefresh 
      Caption         =   "&Refresh"
      Height          =   375
      Left            =   1800
      TabIndex        =   4
      Top             =   2520
      Width           =   975
   End
   Begin VB.CommandButton cmdCancel 
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   3000
      TabIndex        =   5
      Top             =   2520
      Width           =   975
   End
   Begin VB.CommandButton cmdOK 
      Caption         =   "O&K"
      Height          =   375
      Left            =   600
      TabIndex        =   3
      Top             =   2520
      Width           =   975
   End
   Begin VB.ComboBox cboRoles 
      Height          =   315
      Left            =   1320
      Style           =   2  'Dropdown List
      TabIndex        =   0
      Top             =   840
      Width           =   2295
   End
   Begin VB.TextBox txtLogin 
      Height          =   375
      Left            =   1320
      TabIndex        =   1
      Top             =   1380
      Width           =   2295
   End
   Begin VB.TextBox txtPass 
      Height          =   375
      IMEMode         =   3  'DISABLE
      Left            =   1320
      MaxLength       =   8
      PasswordChar    =   "*"
      TabIndex        =   2
      Top             =   1980
      Width           =   2295
   End
   Begin VB.CheckBox chkRememberme 
      Height          =   195
      Left            =   2760
      TabIndex        =   6
      Top             =   3000
      Width           =   255
   End
   Begin VB.Label lblRememberme 
      Caption         =   "Remember me"
      Height          =   255
      Left            =   3000
      TabIndex        =   11
      Top             =   3000
      Width           =   1095
   End
   Begin VB.Line lnRRShd 
      BorderWidth     =   2
      X1              =   4800
      X2              =   4800
      Y1              =   -120
      Y2              =   3435
   End
   Begin VB.Line lnLRShd 
      BorderColor     =   &H80000005&
      BorderWidth     =   2
      X1              =   4680
      X2              =   4680
      Y1              =   0
      Y2              =   3360
   End
   Begin VB.Line lnBBShd 
      BorderWidth     =   2
      X1              =   -120
      X2              =   4660
      Y1              =   3450
      Y2              =   3450
   End
   Begin VB.Line lnTBShd 
      BorderColor     =   &H00FFFFFF&
      BorderWidth     =   2
      X1              =   0
      X2              =   4560
      Y1              =   3360
      Y2              =   3360
   End
   Begin VB.Line lnRLShd 
      BorderWidth     =   2
      X1              =   90
      X2              =   90
      Y1              =   0
      Y2              =   3360
   End
   Begin VB.Line lnLLShd 
      BorderColor     =   &H80000005&
      BorderWidth     =   2
      X1              =   -120
      X2              =   -120
      Y1              =   -120
      Y2              =   3480
   End
   Begin VB.Line lnBTShd 
      BorderWidth     =   2
      X1              =   0
      X2              =   4575
      Y1              =   -15
      Y2              =   0
   End
   Begin VB.Line lnTTShd 
      BorderColor     =   &H00FFFFFF&
      BorderWidth     =   2
      X1              =   -120
      X2              =   4695
      Y1              =   -120
      Y2              =   -105
   End
   Begin VB.Label lblLogin 
      Caption         =   "Login"
      Height          =   255
      Left            =   600
      TabIndex        =   10
      Top             =   1440
      Width           =   495
   End
   Begin VB.Label lblPassword 
      Caption         =   "Password"
      Height          =   255
      Left            =   600
      TabIndex        =   9
      Top             =   2040
      Width           =   735
   End
   Begin VB.Label lblHeading 
      Alignment       =   2  'Center
      BackColor       =   &H00800000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Your title goes here"
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   12
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00FFFFC0&
      Height          =   375
      Left            =   240
      TabIndex        =   8
      Top             =   240
      Width           =   4335
   End
   Begin VB.Label lblLoginas 
      Caption         =   "Login as"
      Height          =   255
      Left            =   600
      TabIndex        =   7
      Top             =   840
      Width           =   735
   End
End
Attribute VB_Name = "VJLogin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Attribute VB_Ext_KEY = "PropPageWizardRun" ,"Yes"
'Default Property Values:
Const m_def_Borders = True
Const m_def_EnableEncription = True
Const m_def_RoleEnabled = True
Const m_def_RememberMeVisible = False
'Const m_def_VJLCError = 0
Const m_def_LoginPassword = ""
Private Const GLB_DEL = 225 'This is the separator for the password characters
Private Const REARR_VAL = 50 'This is the rearranging value of the randomly generated characters
Private m_Borders As Boolean
Private m_RoleEnabled As Boolean
Private m_RememberMeVisible As Boolean
Private m_EnableEncription
Private PassChar() As String 'The password string array just before final unsplit
Private OrderSeq() As Integer 'the sequence of the random sequence of characters
Private RandChar() As Integer 'the random characters generated for each pass char
Private RandCharsBase() As Integer 'the base chars of above(-rearr_val)
Private strSplit() As String 'for decryption
Dim strFinal As String 'The Encrypted PAssword

Event RememberMeChecked()
Event OKClicked()
Event CancelClicked()
Event RoleSelected(index As Integer)
Event KeyPress(KeyAscii As Integer)
Attribute KeyPress.VB_Description = "Occurs when the user presses and releases an ANSI key."
Event RefreshClicked()
Event VJLCErrorFired(Errorcode As VJLCErrorcode)
Public Enum VJLCErrorcode
    VJLC_NO_ERR         'No Error
    VJLC_INIT_ERR       'Initialization error
    VJLC_SYS_ERR        'System error
    VJLC_REGSTN_ERR     'Registration Error
    VJLC_IVLD_BCK_PRCSS 'Invalid back process for remembering the password without user notification
    VJLC_INVLD_CHAR     'Invalid Character
    VJLC_INVLD_PROP     'Invalid PRoperty
    VJLC_INVLD_INDX     'Invalid index for cboRoles
    VJLC_LEN_ERR        'LEngth error
    VJLC_EMPTY          'Empty string
    VJLC_ENCRP_ERR      'Some encr error
    VJLC_DECRP_ERR      'Some decr error
    VJLC_RESZE_ERR      'Resizing errro
    VJLC_ENCRP_DSBLD_INFO 'Encription disabled info
End Enum


Private Sub cboRoles_KeyPress(KeyAscii As Integer)
RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub chkRememberme_Click()
RaiseEvent RememberMeChecked
End Sub

Private Sub cmdCancel_KeyPress(KeyAscii As Integer)
RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub cmdOK_KeyPress(KeyAscii As Integer)
RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub Command1_Click()

End Sub

Private Sub txtLogin_KeyPress(KeyAscii As Integer)
RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub txtPass_KeyPress(KeyAscii As Integer)
RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_Initialize()
On Error GoTo ED

Exit Sub
ED:
    RaiseEvent VJLCErrorFired(VJLC_INIT_ERR)
    
End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub UserControl_Resize()
On Error GoTo ED
If Width < 4455 Or Width > 4455 Then
    Width = 4455
    ScaleWidth = Width
End If
If Height < 3615 Or Height > 3615 Then
    Height = 3615
    ScaleHeight = Height
End If
'fraContainer.Move 0, 0, ScaleWidth, ScaleHeight
lblHeading.Move ScaleLeft + 150, Top + 150, Width - 320, 400
lblLoginas.Left = lblHeading.Left + 350
lblLogin.Left = lblLoginas.Left
lblPassword.Left = lblLogin.Left
txtPass.Left = lblPassword.Left + lblPassword.Width + 20
txtLogin.Left = txtPass.Left
cboRoles.Left = txtPass.Left
cmdOK.Move lblLogin.Left, lblPassword.Top + lblPassword.Height + 250
With cmdOK
cmdRefresh.Move .Left + .Width + 100, .Top, .Width, .Height
cmdCancel.Move cmdRefresh.Left + .Width + 100, .Top, .Width, .Height
End With
'lblHeading.ZOrder 1
With lnLLShd
    .X1 = 15
    .X2 = 15
    .Y1 = 0
    .Y2 = Height
End With

With lnRLShd
    .X1 = lnLLShd.X2 + 100
    .X2 = .X1
     .Y1 = 120
    .Y2 = Height - 180
End With
With lnRRShd
    .X1 = Width - 30
    .X2 = .X1
    .Y1 = 0
    .Y2 = Height - 40
End With

With lnLRShd
    .X1 = lnRRShd.X1 - 120
    .X2 = .X1
    .Y1 = 120
    .Y2 = Height - 160
End With
With lnTTShd
    .Y1 = 15
    .Y2 = 15
    .X1 = 15
    .X2 = Width - 40
End With
With lnBTShd
     .Y1 = lnTTShd.Y2 + 120
    .Y2 = .Y1
    .X1 = 100
    .X2 = Width - 180
End With
With lnBBShd
     .Y1 = Height - 30
    .Y2 = .Y1
    .X1 = 0
    .X2 = Width - 40
End With
With lnTBShd
     .Y1 = lnBBShd.Y1 - 120
    .Y2 = .Y1
    .X1 = 100
    .X2 = Width - 180
End With
Exit Sub
ED:
    RaiseEvent VJLCErrorFired(VJLC_RESZE_ERR)
End Sub
Public Property Get BackColor() As OLE_COLOR
Attribute BackColor.VB_Description = "Returns/sets the background color used to display text and graphics in an object."
    BackColor = lblHeading.BackColor
End Property

Public Property Let BackColor(ByVal New_BackColor As OLE_COLOR)
On Error GoTo ED
    lblHeading.BackColor() = New_BackColor
    PropertyChanged "BackColor"
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Property Get ForeColor() As OLE_COLOR
Attribute ForeColor.VB_Description = "Returns/sets the foreground color used to display text and graphics in an object."
    ForeColor = lblHeading.ForeColor
End Property

Public Property Let ForeColor(ByVal New_ForeColor As OLE_COLOR)
On Error GoTo ED
    lblHeading.ForeColor() = New_ForeColor
    PropertyChanged "ForeColor"
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Property Get Enabled() As Boolean
Attribute Enabled.VB_Description = "Returns/sets a value that determines whether an object can respond to user-generated events."
    Enabled = UserControl.Enabled
End Property

Public Property Let Enabled(ByVal New_Enabled As Boolean)
On Error GoTo ED
    UserControl.Enabled() = New_Enabled
    PropertyChanged "Enabled"
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Property Get Font() As Font
Attribute Font.VB_Description = "Returns a Font object."
Attribute Font.VB_UserMemId = -512
    Set Font = lblHeading.Font
End Property

Public Property Set Font(ByVal New_Font As Font)
On Error GoTo ED
    Set lblHeading.Font = New_Font
    PropertyChanged "Font"
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Property Get BorderStyle() As Integer
Attribute BorderStyle.VB_Description = "Returns/sets the border style for an object."
Attribute BorderStyle.VB_ProcData.VB_Invoke_Property = "General"
    BorderStyle = lblHeading.BorderStyle
End Property

Public Property Let BorderStyle(ByVal New_BorderStyle As Integer)
On Error GoTo ED
    lblHeading.BorderStyle() = New_BorderStyle
    PropertyChanged "BorderStyle"
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Sub Refresh()
Attribute Refresh.VB_Description = "Forces a complete repaint of a object."
    UserControl.Refresh
End Sub



Public Property Get Alignment() As Integer
Attribute Alignment.VB_Description = "Returns/sets the alignment of a CheckBox or OptionButton, or a control's text."
Attribute Alignment.VB_ProcData.VB_Invoke_Property = "General"

    Alignment = lblHeading.Alignment

End Property

Public Property Let Alignment(ByVal New_Alignment As Integer)
On Error GoTo ED
    lblHeading.Alignment() = New_Alignment
    PropertyChanged "Alignment"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Sub AddItem(ByVal Item As String, Optional ByVal index As Variant)
Attribute AddItem.VB_Description = "Adds an item to a Listbox or ComboBox control or a row to a Grid control."
On Error GoTo ED
    cboRoles.AddItem Item, index
Exit Sub
ED:

RaiseEvent VJLCErrorFired(VJLC_INVLD_INDX)
End Sub

Public Property Get AutoRedraw() As Boolean
Attribute AutoRedraw.VB_Description = "Returns/sets the output from a graphics method to a persistent bitmap."
Attribute AutoRedraw.VB_ProcData.VB_Invoke_Property = "General"
    AutoRedraw = UserControl.AutoRedraw
End Property

Public Property Let AutoRedraw(ByVal New_AutoRedraw As Boolean)
On Error GoTo ED
    UserControl.AutoRedraw() = New_AutoRedraw
    PropertyChanged "AutoRedraw"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property



Public Sub Clear()
Attribute Clear.VB_Description = "Clears the contents of a control or the system Clipboard."
    cboRoles.Clear
End Sub

Public Property Get FontName() As String
Attribute FontName.VB_Description = "Specifies the name of the font that appears in each row for the given level."
Attribute FontName.VB_ProcData.VB_Invoke_Property = "TitleFont"
    FontName = lblHeading.FontName
End Property

Public Property Let FontName(ByVal New_FontName As String)
On Error GoTo ED
    lblHeading.FontName() = New_FontName
    PropertyChanged "FontName"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Property Get FontSize() As Single
Attribute FontSize.VB_Description = "Specifies the size (in points) of the font that appears in each row for the given level."
Attribute FontSize.VB_ProcData.VB_Invoke_Property = "TitleFont"
    FontSize = lblHeading.FontSize
End Property

Public Property Let FontSize(ByVal New_FontSize As Single)
On Error GoTo ED
    lblHeading.FontSize() = New_FontSize
    PropertyChanged "FontSize"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Property Get FontBold() As Boolean
Attribute FontBold.VB_Description = "Returns/sets bold font styles."
Attribute FontBold.VB_ProcData.VB_Invoke_Property = "TitleFont"
    FontBold = lblHeading.FontBold
End Property

Public Property Let FontBold(ByVal New_FontBold As Boolean)
On Error GoTo ED
    lblHeading.FontBold() = New_FontBold
    PropertyChanged "FontBold"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Property Get HasDC() As Boolean
Attribute HasDC.VB_Description = "Determines whether a unique display context is allocated for the control."
    HasDC = UserControl.HasDC
End Property

Public Property Get hDC() As Long
Attribute hDC.VB_Description = "Returns a handle (from Microsoft Windows) to the object's device context."
    hDC = UserControl.hDC
End Property

Public Property Get hWnd() As Long
Attribute hWnd.VB_Description = "Returns a handle (from Microsoft Windows) to an object's window."
    hWnd = UserControl.hWnd
End Property

Public Property Get ListIndex() As Integer
Attribute ListIndex.VB_Description = "Returns/sets the index of the currently selected item in the control."
    ListIndex = cboRoles.ListIndex
End Property

Public Property Let ListIndex(ByVal New_ListIndex As Integer)
On Error GoTo ED
    cboRoles.ListIndex() = New_ListIndex
    PropertyChanged "ListIndex"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Property Get PasswordChar() As String
Attribute PasswordChar.VB_Description = "Returns/sets a value that determines whether characters typed by a user or placeholder characters are displayed in a control."
Attribute PasswordChar.VB_ProcData.VB_Invoke_Property = "Password"
    PasswordChar = txtPass.PasswordChar
End Property

Public Property Let PasswordChar(ByVal New_PasswordChar As String)
On Error GoTo ED
    txtPass.PasswordChar() = New_PasswordChar
    PropertyChanged "PasswordChar"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Private Sub UserControl_ReadProperties(Propbag As PropertyBag)
    lblHeading.BackColor = Propbag.ReadProperty("BackColor", &H8000000F)
    lblHeading.ForeColor = Propbag.ReadProperty("ForeColor", &HFFFFC0)
    UserControl.Enabled = Propbag.ReadProperty("Enabled", True)
    Set lblHeading.Font = Propbag.ReadProperty("Font", Ambient.Font)
    lblHeading.BorderStyle = Propbag.ReadProperty("BorderStyle", 1)
    lblHeading.Alignment = Propbag.ReadProperty("Alignment", 2)
    UserControl.AutoRedraw = Propbag.ReadProperty("AutoRedraw", False)
    lblHeading.FontName = Propbag.ReadProperty("FontName", "MS Sans Serif")
    lblHeading.FontSize = Propbag.ReadProperty("FontSize", 14)
    lblHeading.FontBold = Propbag.ReadProperty("FontBold", 0)
    cboRoles.ListIndex = Propbag.ReadProperty("ListIndex", -1)
    txtPass.PasswordChar = Propbag.ReadProperty("PasswordChar", "*")
    UserControl.ScaleHeight = Propbag.ReadProperty("ScaleHeight", 3660)
    UserControl.ScaleLeft = Propbag.ReadProperty("ScaleLeft", 0)
    UserControl.ScaleMode = Propbag.ReadProperty("ScaleMode", 1)
    UserControl.ScaleTop = Propbag.ReadProperty("ScaleTop", 0)
    UserControl.ScaleWidth = Propbag.ReadProperty("ScaleWidth", 4995)
    txtLogin.Text = Propbag.ReadProperty("Text", "")
    lblHeading.ToolTipText = Propbag.ReadProperty("ToolTipText", "")
    lblHeading.Caption = Propbag.ReadProperty("Caption", "Your title goes here")
    m_Borders = Propbag.ReadProperty("Borders", m_def_Borders)
    
    m_EnableEncription = Propbag.ReadProperty("EnableEncription", m_def_EnableEncription)
    m_RoleEnabled = Propbag.ReadProperty("RoleEnabled", m_def_RoleEnabled)
    m_RememberMeVisible = Propbag.ReadProperty("RememberMeVisible", m_def_RememberMeVisible)
    SetBorders
    SetRole
    SetRemberme
End Sub

Public Sub RemoveItem(ByVal index As Integer)
Attribute RemoveItem.VB_Description = "Removes an item from a ListBox or ComboBox control or a row from a Grid control."
On Error GoTo ED
    cboRoles.RemoveItem index
Exit Sub
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_INDX)
End Sub

Public Property Get ScaleHeight() As Single
Attribute ScaleHeight.VB_Description = "Returns/sets the number of units for the vertical measurement of an object's interior."
    ScaleHeight = UserControl.ScaleHeight
End Property

Public Property Let ScaleHeight(ByVal New_ScaleHeight As Single)
On Error GoTo ED
    UserControl.ScaleHeight() = New_ScaleHeight
    PropertyChanged "ScaleHeight"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Property Get ScaleLeft() As Single
Attribute ScaleLeft.VB_Description = "Returns/sets the horizontal coordinates for the left edges of an object."
    ScaleLeft = UserControl.ScaleLeft
End Property

Public Property Let ScaleLeft(ByVal New_ScaleLeft As Single)
On Error GoTo ED
    UserControl.ScaleLeft() = New_ScaleLeft
    PropertyChanged "ScaleLeft"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Property Get ScaleMode() As Integer
Attribute ScaleMode.VB_Description = "Returns/sets a value indicating measurement units for object coordinates when using graphics methods or positioning controls."
    ScaleMode = UserControl.ScaleMode
End Property

Public Property Let ScaleMode(ByVal New_ScaleMode As Integer)
On Error GoTo ED
    UserControl.ScaleMode() = New_ScaleMode
    PropertyChanged "ScaleMode"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Property Get ScaleTop() As Single
Attribute ScaleTop.VB_Description = "Returns/sets the vertical coordinates for the top edges of an object."
    ScaleTop = UserControl.ScaleTop
End Property

Public Property Let ScaleTop(ByVal New_ScaleTop As Single)
On Error GoTo ED
    UserControl.ScaleTop() = New_ScaleTop
    PropertyChanged "ScaleTop"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Property Get ScaleWidth() As Single
Attribute ScaleWidth.VB_Description = "Returns/sets the number of units for the horizontal measurement of an object's interior."
    ScaleWidth = UserControl.ScaleWidth
End Property

Public Property Let ScaleWidth(ByVal New_ScaleWidth As Single)
On Error GoTo ED
    UserControl.ScaleWidth() = New_ScaleWidth
    PropertyChanged "ScaleWidth"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Property Get Sorted() As Boolean
Attribute Sorted.VB_Description = "Indicates whether the elements of a control are automatically sorted alphabetically."
    Sorted = cboRoles.Sorted
End Property

Public Property Get Text() As String
Attribute Text.VB_Description = "Returns/sets the text contained in the control."
Attribute Text.VB_ProcData.VB_Invoke_Property = "Password"
    Text = txtLogin.Text
End Property
Public Property Get Password() As String
Password = txtPass.Text
End Property
Public Property Let Password(new_Pass As String)
If Len(new_Pass) > 8 Then
    RaiseEvent VJLCErrorFired(VJLC_LEN_ERR)
Else
    txtPass.Text() = new_Pass
End If
End Property
Public Property Let Text(ByVal New_Text As String)
On Error GoTo ED
    txtLogin.Text() = New_Text
    PropertyChanged "Text"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Property Get ToolTipText() As String
Attribute ToolTipText.VB_Description = "Returns/sets the text displayed when the mouse is paused over the control."
Attribute ToolTipText.VB_ProcData.VB_Invoke_Property = "General"
    ToolTipText = lblHeading.ToolTipText
End Property

Public Property Let ToolTipText(ByVal New_ToolTipText As String)
On Error GoTo ED
    lblHeading.ToolTipText() = New_ToolTipText
    PropertyChanged "ToolTipText"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Property Get Caption() As String
Attribute Caption.VB_Description = "Returns/sets the text displayed in an object's title bar or below an object's icon."
Attribute Caption.VB_ProcData.VB_Invoke_Property = "General"
    Caption = lblHeading.Caption
End Property

Public Property Let Caption(ByVal New_Caption As String)
On Error GoTo ED
    lblHeading.Caption() = New_Caption
    PropertyChanged "Caption"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Private Sub UserControl_WriteProperties(Propbag As PropertyBag)
    On Error GoTo ED
    Call Propbag.WriteProperty("BackColor", lblHeading.BackColor, &H8000000F)
    Call Propbag.WriteProperty("ForeColor", lblHeading.ForeColor, &HFFFFC0)
    Call Propbag.WriteProperty("Enabled", UserControl.Enabled, True)
    Call Propbag.WriteProperty("Font", lblHeading.Font, Ambient.Font)
    Call Propbag.WriteProperty("BorderStyle", lblHeading.BorderStyle, 1)
    Call Propbag.WriteProperty("Alignment", lblHeading.Alignment, 2)
    Call Propbag.WriteProperty("AutoRedraw", UserControl.AutoRedraw, False)
    Call Propbag.WriteProperty("FontName", lblHeading.FontName, "")
    Call Propbag.WriteProperty("FontSize", lblHeading.FontSize, 0)
    Call Propbag.WriteProperty("FontBold", lblHeading.FontBold, 0)
    Call Propbag.WriteProperty("ListIndex", cboRoles.ListIndex, 0)
    Call Propbag.WriteProperty("PasswordChar", txtPass.PasswordChar, "*")
    Call Propbag.WriteProperty("ScaleHeight", UserControl.ScaleHeight, 3660)
    Call Propbag.WriteProperty("ScaleLeft", UserControl.ScaleLeft, 0)
    Call Propbag.WriteProperty("ScaleMode", UserControl.ScaleMode, 1)
    Call Propbag.WriteProperty("ScaleTop", UserControl.ScaleTop, 0)
    Call Propbag.WriteProperty("ScaleWidth", UserControl.ScaleWidth, 4995)
    Call Propbag.WriteProperty("Text", txtLogin.Text, "")
    Call Propbag.WriteProperty("ToolTipText", lblHeading.ToolTipText, "")
    Call Propbag.WriteProperty("Caption", lblHeading.Caption, "Your title goes here")
    Call Propbag.WriteProperty("Borders", m_Borders, m_def_Borders)
    Call Propbag.WriteProperty("EnableEncription", m_EnableEncription, m_def_EnableEncription)
    Call Propbag.WriteProperty("RoleEnabled", m_RoleEnabled, m_def_RoleEnabled)
    Call Propbag.WriteProperty("RememberMeVisible", m_RememberMeVisible, m_def_RememberMeVisible)

Exit Sub
ED:
    
    RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Sub

Public Property Get Borders() As Boolean
Attribute Borders.VB_Description = "Sets the 3D borders"
Attribute Borders.VB_ProcData.VB_Invoke_Property = "General"
    Borders = m_Borders
End Property

Public Property Let Borders(ByVal New_Borders As Boolean)
On Error GoTo ED
    If Ambient.UserMode Then Err.Raise 382
    m_Borders = New_Borders
    PropertyChanged "Borders"
    SetBorders
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Public Property Get EnableEncription() As Boolean
Attribute EnableEncription.VB_Description = "Enables internal Encription"
Attribute EnableEncription.VB_ProcData.VB_Invoke_Property = "Password"
    EnableEncription = m_EnableEncription
End Property

Public Property Let EnableEncription(ByVal New_EnableEncription As Boolean)
On Error GoTo ED
    m_EnableEncription = New_EnableEncription
    PropertyChanged "EnableEncription"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property

Private Sub cmdOK_Click()
If Trim$(txtLogin.Text) = "" Then
    RaiseEvent VJLCErrorFired(VJLC_EMPTY)
End If
    RaiseEvent OKClicked
End Sub

Private Sub cmdCancel_Click()
    RaiseEvent CancelClicked
End Sub
Private Sub cmdRefresh_Click()
ClearLoginPassword
RaiseEvent RefreshClicked
End Sub
Public Property Get RoleEnabled() As Boolean
Attribute RoleEnabled.VB_Description = "Makes the roles combobox visible/invisible"
Attribute RoleEnabled.VB_ProcData.VB_Invoke_Property = "Password"
    RoleEnabled = m_RoleEnabled
End Property

Public Property Let RoleEnabled(ByVal New_RoleEnabled As Boolean)
On Error GoTo ED
    m_RoleEnabled = New_RoleEnabled
    SetRole
    PropertyChanged "RoleEnabled"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property
Public Property Get RememberMeVisible() As Boolean
RememberMeVisible = m_RememberMeVisible
End Property

Public Property Let RememberMeVisible(ByVal New_RememberMeVisible As Boolean)
On Error GoTo ED
    m_RememberMeVisible = New_RememberMeVisible
    SetRemberme
    PropertyChanged "RememberMeVisible"
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property
Public Property Get RememberMe() As Boolean
RememberMe = (chkRememberme.Value = vbChecked)
End Property
Public Property Let RememberMe(new_Rem As Boolean)
On Error GoTo ED
If RememberMeVisible Then
    chkRememberme.Value = (new_Rem And vbChecked)
Else
    RaiseEvent VJLCErrorFired(VJLC_IVLD_BCK_PRCSS)
End If
Exit Property
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_PROP)
End Property
Private Sub cboRoles_Click()
    RaiseEvent RoleSelected(cboRoles.ListIndex)
End Sub

Public Function EncryptPassword(Optional ByVal strP As String) As String
Attribute EncryptPassword.VB_Description = "Encripts Password(only if Enable Encription is set true)"
On Error GoTo ED
If EnableEncription Then
    Dim strTemp As String
    Dim cnt As Integer
    Dim strTemp1 As String
    If strP = "" Then
        strTemp = txtPass.Text
    Else
        If Len(strP) > txtPass.MaxLength Then
            RaiseEvent VJLCErrorFired(VJLC_LEN_ERR)
            Exit Function
        Else
            strTemp = strP
        End If
    End If
    strTemp1 = strTemp
    ReDim PassChar(0 To Len(strTemp))
    GenRanOrd strTemp
    strFinal = ""
    For cnt = 0 To UBound(PassChar)
        strFinal = strFinal & PassChar(cnt)
    Next
    If DecryptPassword(strFinal) <> strTemp Then
        ReDim strSplit(0)
        ReDim OrderSeq(0)
        ReDim RandChar(0)
        ReDim RandCharsBase(0)
        Call EncryptPassword(strTemp1)
    End If
    EncryptPassword = strFinal
Else
    RaiseEvent VJLCErrorFired(VJLC_ENCRP_DSBLD_INFO)
End If
Exit Function
ED:
RaiseEvent VJLCErrorFired(VJLC_ENCRP_ERR)
End Function

Public Function DecryptPassword(strP As String) As String
If EnableEncription Then
    Dim cnt As Integer
    Dim strTemp As String
    On Error GoTo ED
    strSplit = Split(strP, Chr(GLB_DEL), , vbTextCompare)
    RearrangeCharacters
    For cnt = 0 To UBound(strSplit) - 1
            strTemp = strTemp & strSplit(cnt)
    Next
    DecryptPassword = strTemp
Else
    RaiseEvent VJLCErrorFired(VJLC_ENCRP_DSBLD_INFO)
End If
Exit Function
ED:
RaiseEvent VJLCErrorFired(VJLC_DECRP_ERR)
End Function

Public Function ClearLoginPassword() As Variant
Attribute ClearLoginPassword.VB_Description = "Clears only login and password fields"
txtLogin.Text = ""
txtPass.Text = ""

End Function

Public Function ClearAll() As Boolean
Attribute ClearAll.VB_Description = "Clears all the controls in the Usercontrol"
txtLogin.Text = ""
txtPass.Text = ""
cboRoles.Clear
End Function

'Initialize Properties for User Control
Private Sub UserControl_InitProperties()
On Error GoTo ED
SetBorders
SetRole
SetRemberme
Exit Sub
ED:
    RaiseEvent VJLCErrorFired(VJLC_INIT_ERR)
End Sub
Private Sub SetBorders()
If Borders Then
    lnBTShd.Visible = True
    lnBBShd.Visible = True
    lnTBShd.Visible = True
    lnTTShd.Visible = True
    lnLLShd.Visible = True
    lnRLShd.Visible = True
    lnRRShd.Visible = True
    lnLRShd.Visible = True
ElseIf Not Borders Then
    lnBTShd.Visible = False
    lnBBShd.Visible = False
    lnTBShd.Visible = False
    lnTTShd.Visible = False
    lnLLShd.Visible = False
    lnRLShd.Visible = False
    lnRRShd.Visible = False
    lnLRShd.Visible = False
End If
End Sub
Private Sub SetRole()
If m_RoleEnabled Then
    lblLoginas.Visible = True
    cboRoles.Visible = True
ElseIf Not m_RoleEnabled Then
    lblLoginas.Visible = False
    cboRoles.Visible = False
End If
End Sub

Private Sub GenRanOrd(strP As String)
On Error GoTo ED
Dim val1 As Integer
Dim val2 As Integer
Dim val3 As Integer
ReDim OrderSeq(0 To Len(strP) - 1)
'Randomize
Do Until OrderSeq(Len(strP) - 1) > 0
    val1 = Int(((Len(strP)) * Rnd) + 1)
    
    For val2 = 0 To UBound(OrderSeq)
        If OrderSeq(val2) = val1 Then
            GoTo NEX
        End If
    Next
    OrderSeq(val3) = val1
    val3 = val3 + 1
NEX:
Loop
GenRandChar val3, strP
Exit Sub
ED:
RaiseEvent VJLCErrorFired(VJLC_ENCRP_ERR)
End Sub
Private Sub GenRandChar(lt As Integer, strP As String)
Dim val1 As Integer
Dim val2 As Integer
Dim val3 As Integer
ReDim RandChar(0 To lt - 1)
Randomize
For val2 = 0 To lt - 1
    RandChar(val2) = Int((33 * Rnd) + 50)
    PassChar(val2) = Chr(Asc(Mid$(strP, OrderSeq(val2), 1)) + RandChar(val2))
    RandChar(val2) = RandChar(val2) - REARR_VAL  '50 ->48 just for confusion
    PassChar(val2) = RandChar(val2) & PassChar(val2) & OrderSeq(val2) & Chr(GLB_DEL)
Next

End Sub
Private Sub RearrangeCharacters()
Dim cnt1 As Integer
Dim cnt2 As Integer
Dim strTemp() As String
On Error GoTo ED
ReDim strTemp(0 To (UBound(strSplit)))
For cnt1 = 0 To UBound(strSplit) - 1
    cnt2 = Right$(strSplit(cnt1), 1)
    strTemp(cnt2 - 1) = Left$(strSplit(cnt1), Len(strSplit(cnt1)) - 1)
    strTemp(cnt2 - 1) = Chr(Asc(Right$(strTemp(cnt2 - 1), 1)) - (Left$(strTemp(cnt2 - 1), Len(strTemp(cnt2 - 1)) - 1) + REARR_VAL))
Next
strSplit = strTemp
Exit Sub
ED:
RaiseEvent VJLCErrorFired(VJLC_INVLD_CHAR)
End Sub
Private Sub SetRemberme()
chkRememberme.Visible = RememberMeVisible
lblRememberme.Visible = RememberMeVisible
End Sub
